Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.zip
Class ZipInputStream

    java.lang.Object
      |
      +--java.io.InputStream
            |
            +--java.io.FilterInputStream
                  |
                  +--java.util.zip.InflaterInputStream
                        |
                        +--java.util.zip.ZipInputStream

All Implemented Interfaces:
  java.util.zip.ZipConstants

Direct Known Subclasses:
  JarInputStream

public class ZipInputStream
extends InflaterInputStream
implements java.util.zip.ZipConstants

This class implements an input stream filter for reading files in the ZIP file format. Includes support for both compressed and uncompressed entries.

Field Summary
`static int` | `CENATT`
`static int` | `CENATX`
`static int` | `CENCOM`
`static int` | `CENCRC`
`static int` | `CENDSK`
`static int` | `CENEXT`
`static int` | `CENFLG`
`static int` | `CENHDR`
`static int` | `CENHOW`
`static int` | `CENLEN`
`static int` | `CENNAM`
`static int` | `CENOFF`
`static long` | `CENSIG`
`static int` | `CENSIZ`
`static int` | `CENTIM`
`static int` | `CENVEM`
`static int` | `CENVER`
`static int` | `ENDCOM`
`static int` | `ENDHDR`
`static int` | `ENDOFF`
`static long` | `ENDSIG`
`static int` | `ENDSIZ`
`static int` | `ENDSUB`
`static int` | `ENDTOT`
`static int` | `EXTCRC`
`static int` | `EXTHDR`
`static int` | `EXTLEN`
`static long` | `EXTSIG`
`static int` | `EXTSIZ`
`static int` | `LOCCRC`
`static int` | `LOCEXT`
`static int` | `LOCFLG`
`static int` | `LOCHDR`
`static int` | `LOCHOW`
`static int` | `LOCLEN`
`static int` | `LOCNAM`
`static long` | `LOCSIG`
`static int` | `LOCSIZ`
`static int` | `LOCTIM`
`static int` | `LOCVER`

Fields inherited from class java.util.zip.InflaterInputStream
`buf, inf, len`

Fields inherited from class java.io.FilterInputStream
`in`

Constructor Summary
`ZipInputStream(InputStream in)` Creates a new ZIP input stream.

Method Summary
`int` | `available()` Returns 0 after EOF has reached for the current entry data, otherwise always return 1.
`void` | `close()` Closes the ZIP input stream.
`void` | `closeEntry()` Closes the current ZIP entry and positions the stream for reading the next entry.
`protected ZipEntry` | `createZipEntry(String name)` Creates a new `ZipEntry` object for the specified entry name.
`ZipEntry` | `getNextEntry()` Reads the next ZIP file entry and positions stream at the beginning of the entry data.
`int` | `read(byte[] b, int off, int len)` Reads from the current ZIP entry into an array of bytes.
`long` | `skip(long n)` Skips specified number of bytes in the current ZIP entry.

Methods inherited from class java.util.zip.InflaterInputStream
`fill, read`

Methods inherited from class java.io.FilterInputStream
`mark, markSupported, read, reset`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### LOCSIG

    public static final long LOCSIG

### EXTSIG

    public static final long EXTSIG

### CENSIG

    public static final long CENSIG

### ENDSIG

    public static final long ENDSIG

### LOCHDR

    public static final int LOCHDR

### EXTHDR

    public static final int EXTHDR

### CENHDR

    public static final int CENHDR

### ENDHDR

    public static final int ENDHDR

### LOCVER

    public static final int LOCVER

### LOCFLG

    public static final int LOCFLG

### LOCHOW

    public static final int LOCHOW

### LOCTIM

    public static final int LOCTIM

### LOCCRC

    public static final int LOCCRC

### LOCSIZ

    public static final int LOCSIZ

### LOCLEN

    public static final int LOCLEN

### LOCNAM

    public static final int LOCNAM

### LOCEXT

    public static final int LOCEXT

### EXTCRC

    public static final int EXTCRC

### EXTSIZ

    public static final int EXTSIZ

### EXTLEN

    public static final int EXTLEN

### CENVEM

    public static final int CENVEM

### CENVER

    public static final int CENVER

### CENFLG

    public static final int CENFLG

### CENHOW

    public static final int CENHOW

### CENTIM

    public static final int CENTIM

### CENCRC

    public static final int CENCRC

### CENSIZ

    public static final int CENSIZ

### CENLEN

    public static final int CENLEN

### CENNAM

    public static final int CENNAM

### CENEXT

    public static final int CENEXT

### CENCOM

    public static final int CENCOM

### CENDSK

    public static final int CENDSK

### CENATT

    public static final int CENATT

### CENATX

    public static final int CENATX

### CENOFF

    public static final int CENOFF

### ENDSUB

    public static final int ENDSUB

### ENDTOT

    public static final int ENDTOT

### ENDSIZ

    public static final int ENDSIZ

### ENDOFF

    public static final int ENDOFF

### ENDCOM

    public static final int ENDCOM

Constructor Detail

### ZipInputStream

    public ZipInputStream(InputStream in)

  Creates a new ZIP input stream.
  Parameters:
    `in` - the actual input stream

Method Detail

### getNextEntry

    public ZipEntry getNextEntry()
                          throws IOException

  Reads the next ZIP file entry and positions stream at the beginning of the entry data.
  Returns:
    the ZipEntry just read
  Throws:
    `ZipException` - if a ZIP file error has occurred
    `IOException` - if an I/O error has occurred

### closeEntry

    public void closeEntry()
                    throws IOException

  Closes the current ZIP entry and positions the stream for reading the next entry.
  Throws:
    `ZipException` - if a ZIP file error has occurred
    `IOException` - if an I/O error has occurred

### available

    public int available()
                  throws IOException

  Returns 0 after EOF has reached for the current entry data, otherwise always return 1.

  Programs should not count on this method to return the actual number of bytes that could be read without blocking.

  Overrides:
    `available` in class `InflaterInputStream`
  Returns:
    1 before EOF and 0 after EOF has reached for current entry.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Reads from the current ZIP entry into an array of bytes. Blocks until some input is available.
  Overrides:
    `read` in class `InflaterInputStream`
  Parameters:
    `b` - the buffer into which the data is read
    `off` - the start offset of the data
    `len` - the maximum number of bytes read
  Returns:
    the actual number of bytes read, or -1 if the end of the entry is reached
  Throws:
    `ZipException` - if a ZIP file error has occurred
    `IOException` - if an I/O error has occurred

### skip

    public long skip(long n)
              throws IOException

  Skips specified number of bytes in the current ZIP entry.
  Overrides:
    `skip` in class `InflaterInputStream`
  Parameters:
    `n` - the number of bytes to skip
  Returns:
    the actual number of bytes skipped
  Throws:
    `ZipException` - if a ZIP file error has occurred
    `IOException` - if an I/O error has occurred
    `IllegalArgumentException` - if n < 0

### close

    public void close()
               throws IOException

  Closes the ZIP input stream.
  Overrides:
    `close` in class `InflaterInputStream`
  Throws:
    `IOException` - if an I/O error has occurred

### createZipEntry

    protected ZipEntry createZipEntry(String name)

  Creates a new `ZipEntry` object for the specified entry name.
  Parameters:
    `name` - the ZIP file entry name
  Returns:
    the ZipEntry just created

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.